// SelPart.cpp : Cve[V t@C
//
//******
//iCũXg{bNX\[g̑ł邱ƂOɂĂB

#include "stdafx.h"
#include "BSch.h"
#include "global.h"

#include "PartLib.h"
#include "Preview.h"
#include "SelPart.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelPart _CAO


CSelPart::CSelPart(CWnd* pParent /*=NULL*/)
	: CDialog(CSelPart::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelPart)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
//	m_nLastSelectPart=0;
	m_nLastSelectLibrary=0;
	m_pwndPreview=NULL;
	m_bUsePreview=FALSE;
}


void CSelPart::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelPart)
                //  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelPart, CDialog)
	//{{AFX_MSG_MAP(CSelPart)
	ON_LBN_SELCHANGE(IDC_LIST_LIBRARY, OnSelchangeListLibrary)
	ON_LBN_SELCHANGE(IDC_LIST_PARTNAME, OnSelchangeListPartname)
	ON_LBN_DBLCLK(IDC_LIST_PARTNAME, OnDblclkListPartname)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//w肵Cu̕iXg{bNXɐݒ肷
void CSelPart::SetPartName(int nLib)
{
	CListBox* pLB=(CListBox*)GetDlgItem(IDC_LIST_PARTNAME);
	pLB->ShowWindow(SW_HIDE);
	//ȇS
	int n=pLB->GetCount();			//o^ς݂̐𓾂
	while(n) n=pLB->DeleteString(0);//c肪擪̕
	m_nPartCount=0;
	CPartIndex* pPartIndex;
	if(g_pPartLib[nLib]!=NULL){
		m_nPartCount=g_pPartLib[nLib]->GetPartCount();	//Cuɓo^Ă镔i
		for(n=0;n<m_nPartCount;n++){
			pPartIndex=g_pPartLib[nLib]->GetPartIndex(n);
			pLB->AddString(pPartIndex->GetName(NULL));
		}
		//ݒ肵iAOIȉԍ𖞂Ȃꍇ
		//ȎINAB
		if(m_nPartCount-1< g_pPartLib[nLib]->m_nLastSelectIndex){
			g_pPartLib[nLib]->m_nLastSelectIndex=0;
		}
		pLB->SetCurSel(g_pPartLib[nLib]->m_nLastSelectIndex);	//OÎɃJ[\u
		CString rStrPartName;
		pLB->GetText(g_pPartLib[nLib]->m_nLastSelectIndex,rStrPartName);
		SetEditPartName(rStrPartName);
		if(m_pwndPreview)  //vr[̍XV
		{
			int nSel=g_pPartLib[nLib]->m_nLastSelectIndex;
			CPartIndex* pPartIndex=g_pPartLib[m_nLastSelectLibrary]->GetPartIndex(nSel);
			m_pwndPreview->SetPartIndex(pPartIndex);
		}
	}else{//w肵CuƂ̏
	//		m_nLastSelectPart=0;
	}
	pLB->ShowWindow(SW_SHOW);
}

//Cu̖OXg{bNXɐݒ肷
//\Cut@C̃pX疼OɕύX  1997/01/21
void CSelPart::SetLibraryName()
{
	char szLibPath[_MAX_PATH];
	char szLibName[_MAX_FNAME];
	CListBox* pLB=(CListBox*)GetDlgItem(IDC_LIST_LIBRARY);
	int n=pLB->GetCount();			//o^ς݂̐𓾂
	while(n) n=pLB->DeleteString(0);//c肪擪̕
	
	for(n=0;n<MAX_LIB;n++){
		if(g_pPartLib[n]==NULL) break;
		g_pPartLib[n]->GetLibraryName(szLibPath);
		_splitpath(szLibPath,NULL,NULL,szLibName,NULL);
		pLB->AddString(szLibName);
	}
	m_nLibraryCount=n;
	//ݒ肵CuAOICuԍ𖞂Ȃꍇ
	//ȎINABƁAƂ͌o[Wł͂Ȃ̂
	if(m_nLibraryCount-1<m_nLastSelectLibrary){
		m_nLastSelectLibrary=0;
		//m_nLastSelectPart=0;
	}
	pLB->SetCurSel(m_nLastSelectLibrary);
}

//GfBbgRg[Ƀp[cݒ
void CSelPart::SetEditPartName(LPCSTR psz)
{
	CEdit* pED=(CEdit*)GetDlgItem(IDC_EDIT_PARTNAME);
	pED->SetWindowText(psz);
}

/////////////////////////////////////////////////////////////////////////////
// CSelPart bZ[W nh

BOOL CSelPart::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	//vr[gƂɂ́A_CAO̕LāACPreview̃EChE
	//CreateExB
	if(g_bUsePreview){
		m_pwndPreview=new CPreview;
		GetWindowRect(&m_rcDialog);
		GetClientRect(&m_rcClient);
		int nHeight=m_rcClient.bottom;
		MoveWindow( m_rcDialog.left,m_rcDialog.top,
					m_rcDialog.right-m_rcDialog.left+nHeight,
					m_rcDialog.bottom-m_rcDialog.top);
		CString strClassName=AfxRegisterWndClass(
			CS_VREDRAW|CS_HREDRAW,
			AfxGetApp()->LoadStandardCursor(IDC_ARROW), 
			(HBRUSH)GetStockObject(BLACK_BRUSH));	//wi͍
		m_pwndPreview->CreateEx(
			WS_EX_CLIENTEDGE,
			strClassName,
			"Preview",			//vȂ
			WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL,
			m_rcClient.right,
			6,
			nHeight-6,
			nHeight-12,
			this->m_hWnd,
			(HMENU)IDC_PREVIEW);
	}
	//iGfBbg{bNX̕
	CEdit* pED=(CEdit*)GetDlgItem(IDC_EDIT_PARTNAME);
	pED->SetLimitText(15);
	SetLibraryName();
	SetPartName(m_nLastSelectLibrary);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

//CȗIԂςƂ̃nh
void CSelPart::OnSelchangeListLibrary() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CListBox* pLB=(CListBox*)GetDlgItem(IDC_LIST_LIBRARY);
	m_nLastSelectLibrary=pLB->GetCurSel();
//	m_nLastSelectPart=0;	//CȗIςΑOIp[cONA
	SetPartName(m_nLastSelectLibrary);
}

//ȋIԂςƂ̃nh
void CSelPart::OnSelchangeListPartname() 
{
	int nSel;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CListBox* pLB=(CListBox*)GetDlgItem(IDC_LIST_PARTNAME);
	nSel=pLB->GetCurSel();
	g_pPartLib[m_nLastSelectLibrary]->m_nLastSelectIndex=nSel;
	CString rStrPartName;
	pLB->GetText(g_pPartLib[m_nLastSelectLibrary]->m_nLastSelectIndex,rStrPartName);
	SetEditPartName(rStrPartName);
	if(m_pwndPreview) //vr[̍XV
	{
		CPartIndex* pPartIndex=g_pPartLib[m_nLastSelectLibrary]->GetPartIndex(nSel);
		m_pwndPreview->SetPartIndex(pPartIndex);
	}
}

void CSelPart::OnCancel() 
{
	// TODO: ̈ʒuɓʂȌ㏈ǉĂB
	
	CDialog::OnCancel();
}

void CSelPart::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	CEdit* pED=(CEdit*)GetDlgItem(IDC_EDIT_PARTNAME);
	pED->GetWindowText(m_rStrPartName);
	m_rStrPartName.MakeUpper();	//啶ɕϊ 1997/01/25
	CDialog::OnOK();
}

//iIXg{bNX̃_uNbNőII 1997/01/25
void CSelPart::OnDblclkListPartname() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	OnOK();
}
