///////////////////////////////////////////////////////////////
// zNX BSchBus ̓̒`s܂
//

#include "stdafx.h"
#include "BSch.h"

//#include "SetLib.h"
//#include "BSchDoc.h"
//#include "BSchView.h"

//#include "PartLib.h"
//#include "BSchFont.h"
#include "Global.h"
#include "BSchObj.h"
#include "BSchLine.h"
#include "BSchBus.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_SERIAL(CBSchBus, CObject ,0)

/////////////////////////////////////////////////////////////////////////////
// CBSchBus VAC[[V
//  gĂȂit@C̓o͂WriteCE2() ReadCE2()ōsj
void CBSchBus::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: ̈ʒuɕۑp̃R[hǉĂB
		//ar << m_p0;
	}
	else
	{
		// TODO: ̈ʒuɓǂݍݗp̃R[hǉĂB
		//ar >> m_p0;
	}
}

/////////////////////////////////////////////////////////////////////////////
//`

void CBSchBus::Draw(
			CDC* pDC,						//`
			DWORD dwMode,					//`惂[h
			int  nVExt /* =1 */,			//\{(View)
			int  nWExt /* =1 */,			//\{(Window)
			LPCRECT lprcClip /*=NULL*/)		//Nbv
{
	int x0,y0,x1,y1;
	//`W̐ݒ
	int nWidth=(3*nVExt)/nWExt;
	x0=(m_p0.x*nVExt)/nWExt;
	y0=(m_p0.y*nVExt)/nWExt;
	x1=(m_p1.x*nVExt)/nWExt;
	y1=(m_p1.y*nVExt)/nWExt;
	//Pȉ̂Ƃɂ
	//ȄꍇɌI_₤
	if(nWidth<=1){
		if(m_p0.y==m_p1.y){//Ȃ...
			x1+=1;
		}else if(m_p0.x==m_p1.x){//Ȃ...
			y1+=1;
		}
	}

	int nOldDrawMode,nNewDrawMode;
	CPen penNew;
	CPen* ppenOld;
	//`惂[hɂăy̎ށEFCOPY or XORݒ肷
	if(dwMode & DRAW_DARK){
		penNew.CreatePen(PS_SOLID,nWidth,COL_DARK);
		nNewDrawMode=R2_COPYPEN;
	}else if(dwMode & DRAW_ON){
		penNew.CreatePen(PS_SOLID,nWidth,COL_BUS);
		nNewDrawMode=R2_COPYPEN;
	}else if(dwMode & DRAW_OFF){
		penNew.CreatePen(PS_SOLID,nWidth,RGB(0,0,0));
		nNewDrawMode=R2_COPYPEN;
	}else if(dwMode & DRAW_XOR){
		penNew.CreatePen(PS_SOLID,nWidth,COL_XOR);
		nNewDrawMode=R2_XORPEN;
	}else{
		TRACE("\nsȕ`惂[h(CBSchBus::DrawBody())");
		return;
	}
	ppenOld=pDC->SelectObject(&penNew);			//쐬y̑I
	nOldDrawMode=pDC->SetROP2(nNewDrawMode);	//`惂[h̐ݒ
	pDC->MoveTo(x0,y0);							//n_ֈړ
	pDC->LineTo(x1,y1);							//`
	pDC->SetROP2(nOldDrawMode);					//`惂[h̕A
	pDC->SelectObject(ppenOld);					//y̕A
}

//IuWFNg̕
CBSchObj* CBSchBus::Duplicate()
{
	CBSchBus* pObj=new CBSchBus;
	if(!pObj) return NULL;
	pObj->m_dwType=this->m_dwType;
	pObj->m_dwStus=this->m_dwStus;
	pObj->m_nMoveFrom=this->m_nMoveFrom;
	pObj->m_p0    =this->m_p0;
	pObj->m_p1    =this->m_p1;
	pObj->m_nLayer=this->m_nLayer;
	return (CBSchObj*)pObj;
}

////////////////////////////////////////////////////////////////////////////////
//CE2t@Co
#pragma pack(1)		//\̂̋EPoCgPʂɕύX

//t@Cւ̏
//TRUEBsFALSEԂ
BOOL CBSchBus::WriteCE2(CFile* pFile,CPoint* pOrigin /*=NULL*/)
{
	int nx,ny;
	BOOL bResult=TRUE;
	struct{				//ݗp̍\
		BYTE	bId;	//ID
		BYTE	bStus;	//Xe[^X
		short	x0;		//_ÔwW
		short	y0;		//      xW
		short	x1;		//_P̂wW
		short	y1;		//      xW
	}ce2wire;

	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}


	ce2wire.bId  	=CE2_BUS;
	//ce2wire.bStus	=0;
	ce2wire.bStus	=(m_nLayer & 0x0F)<<4;	//1998/06/27
	ce2wire.x0		=m_p0.x-nx;
	ce2wire.y0		=m_p0.y-ny;
	ce2wire.x1		=m_p1.x-nx;
	ce2wire.y1		=m_p1.y-ny;
	try{
		pFile->Write(&ce2wire,sizeof(ce2wire));
	}
	catch(CFileException *e){
		if(e->m_cause!=CFileException::none) bResult=FALSE;
		e->Delete();
	}
	return bResult;
}

//t@C̓ǂݍ
//TRUEBsFALSEԂ
//ĂяoOIDʂ̂߂ɂPoCgǂݍł
BOOL CBSchBus::ReadCE2(CFile* pFile,BYTE bCE2Id,CPoint* pOrigin /*=NULL*/)
{
	int nx,ny,p;
	struct{				//ǂݍݗp̍\
		BYTE	bStus;	//Xe[^X
		short	x0;		//_ÔwW
		short	y0;		//      xW
		short	x1;		//_P̂wW
		short	y1;		//      xW
	}ce2wire;
	if(bCE2Id!=CE2_BUS) return FALSE;

	UINT uResult=pFile->Read(&ce2wire,sizeof(ce2wire));
	if(uResult<sizeof(ce2wire)) return FALSE;

	if(pOrigin){
		nx=pOrigin->x;
		ny=pOrigin->y;
	}else{
		nx=0;
		ny=0;
	}
    m_dwType=0;
    m_dwStus=0;	
	m_p0.x=ce2wire.x0+nx;
	m_p0.y=ce2wire.y0+ny;
	m_p1.x=ce2wire.x1+nx;
	m_p1.y=ce2wire.y1+ny;

	if(m_p0.y==m_p1.y){//Ȃ...
		//m_p0.x<m_p1.xۏ؂
		if(m_p0.x > m_p1.x){p=m_p0.x; m_p0.x=m_p1.x; m_p1.x=p;}
	}else if(m_p0.x==m_p1.x){//Ȃ...
		//m_p0.y<m_p1.yۏ؂
		if(m_p0.y > m_p1.y){p=m_p0.y; m_p0.y=m_p1.y; m_p1.y=p;}
	}
	//C[̐ݒ
	m_nLayer=(ce2wire.bStus & 0xF0)>>4;
	return TRUE;
}

#pragma pack()		//\̂̋EftHglɖ߂
