// CELIBWR.CPP
//
// CE̕iCȕ

#include "stdafx.h"
#include <assert.h>
#include "ce3io.h"
#include "LCo.h"

#include "PartInfo.h"
#include "LCoData.h"
#include "CeLib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static	DWORD*	pdwNameIndex;	//iCfbNX
//iCfbNXGÃTCY͊ǗiŌ܂

static	WORD*	pwPartIndex;	//iCfbNX
//iCfbNXGÃTCY͊ǗiŌ܂

static	BYTE*	pPartArea;		//i`GA
static	int		nBytePartArea;	//i`GA̎gpς݃TCY
 		
static	WORD*	pwPtnIndex;		//p^[CfbNX
//p^[CfbNXGÃTCY͊Ǘp^[Ō܂

static	WORD*	pwPtnNameIndex;	//p^[CfbNX
//p^[CfbNXGÃTCY͊Ǘp^[Ō܂

static	BYTE*	pPtnArea;		//p^[GA
static	int		nBytePtnArea;	//p^[GA̎gpς݃TCY

static	char*	pTextArea;		//eLXgGA
static	int		nByteTextArea;	//i`GA̎gpς݃TCY

static	BYTE*	pBuffTmp;

class CWordPtr
{
public:
	CString m_str;
	int		m_offset;
};

static CTypedPtrList<CPtrList, CWordPtr*>	m_listWord;
static CTypedPtrList<CPtrList, CWordPtr*>	m_listPascalWord;

static WORD* warrayCE2Part;

//m_listWord̑S
static void ClearListWord()
{
	POSITION pos=m_listWord.GetHeadPosition();
	while(pos){
		CWordPtr* pWord=m_listWord.GetNext(pos);
		delete pWord;
	}
	m_listWord.RemoveAll();
}

//m_listPascalWord̑S
static void ClearListPascalWord()
{
	POSITION pos=m_listPascalWord.GetHeadPosition();
	while(pos){
		CWordPtr* pWord=m_listPascalWord.GetNext(pos);
		delete pWord;
	}
	m_listPascalWord.RemoveAll();
}

//sԍDWORDɕϊ
DWORD g_szPinTodwPin(const char* pszPin,BOOL bNotHide)
{
	DWORD dwPreFix;
	DWORD dwResult;
	if(isalpha(*pszPin)){
		dwPreFix=toupper(*pszPin);
		dwPreFix=((dwPreFix-'A'+1)<<10)&0x7C00;
		pszPin++;
	}else dwPreFix=0;
	dwResult=(atoi(pszPin) & 0x1FF) | dwPreFix;
	if(!bNotHide) dwResult|=0x8000;
	return dwResult;
}


/////////////////////////////////////////////////////////
//eLXgGAɊi[CꕶiNULLI[j̊Ǘ
// CꕶpstreLXgGAɊi[B
//eLXgGÃItZbgԂ
static int RegisterWord(LPCSTR pstr)
{
//	if(!pstr || *pstr==0) return -1;
	if(!pstr) return -1;	//1997/10/08
	CWordPtr* pWord;
	POSITION pos=m_listWord.GetHeadPosition();
	while(pos){
		pWord=m_listWord.GetNext(pos);
		if(pWord->m_str==pstr) return pWord->m_offset;
	}
	pWord=new CWordPtr;
	pWord->m_offset=nByteTextArea;
	pWord->m_str=CString(pstr);
	char* pchar=pTextArea+nByteTextArea;
	while(*pstr){*pchar++=*pstr++;nByteTextArea++;}
	*pchar=0;
	nByteTextArea++;
	m_listWord.AddTail(pWord);
	return pWord->m_offset;
}


///////////////////////////////////////////////
//eLXgGAɊi[s̊Ǘ
//eLXgGÃItZbgԂ
static int RegisterPinNameAsPascalWord(LPCSTR pstr)
{
	if(!pstr || *pstr==0) return -1;
	CWordPtr* pWord;
	POSITION pos=m_listPascalWord.GetHeadPosition();
	while(pos){
		pWord=m_listPascalWord.GetNext(pos);
		if(pWord->m_str==pstr) return pWord->m_offset;
	}
	pWord=new CWordPtr;
	pWord->m_offset=nByteTextArea;
	pWord->m_str=CString(pstr);
	m_listPascalWord.AddTail(pWord);

	char* pchartop=pTextArea+nByteTextArea;
	char* pchar=pchartop+1;
	char ch;
	
	int nlen=0;
	while(*pstr){
		if(*pstr=='\\'){
			pstr++;
			ch=*pstr++;
			if(!ch) break;
			ch|=0x80;
		}else{
			ch=*pstr++;
		}
		*pchar++=ch;
		nlen++;
	}
	*pchartop=(char)nlen;
	nByteTextArea+=(nlen+1);

	return pWord->m_offset;
}


////////////////////////////////////////////////////////////////////
// LCõp^[CE2Cũp^[ɕϊ
// CE2Cũp^[̃oCgԂ
static int LCoPtnToCE2Ptn(CLCoPtn* pLCoPtn,BYTE* pCE2Ptn)
{
	int nCE2Xbyte,nBitmapXbyte;			//X̃oCg
	BYTE *pSrc,*pDst,*pSrcTop,*pDstTop;	//Rs[Ɏg|C^
	BYTE bRMask;
	int  nMaskOffset;

	if(!pLCoPtn) return NULL;

	*((short*)(pCE2Ptn))  =(short)pLCoPtn->m_size.cx;
	*((short*)(pCE2Ptn+2))=(short)pLCoPtn->m_size.cy;

	nCE2Xbyte=(pLCoPtn->m_size.cx+7)/8;
	nBitmapXbyte=((pLCoPtn->m_size.cx+15)/16)*2;

	nMaskOffset=pLCoPtn->m_size.cx/8;
	bRMask=(0xFF00 >>(pLCoPtn->m_size.cx%8)) & 0xFF;

	pSrcTop=pLCoPtn->m_pBuff;
	pDstTop=pCE2Ptn+4;

	int x,y;
	for(y=0;y<pLCoPtn->m_size.cy;y++){
		pSrc=pSrcTop;
		pDst=pDstTop;
		for(x=0;x<nCE2Xbyte;x++) *pDst++=*pSrc++;
		*(pDstTop+nMaskOffset)&=bRMask;
		pSrcTop+=nBitmapXbyte;
		pDstTop+=nCE2Xbyte;
	}
  	return 4+ nCE2Xbyte * pLCoPtn->m_size.cy;
}



///////////////////////////////////////////////////////////
//			rbgp^[ 50% k
// CE2Cũp^[̃oCgԂ
static int ptn50(BYTE* pCE2PtnS,BYTE* pCE2Ptn50)
{
	CSize sizeSrc;
	CSize size50;
	int nXByteS;
	int nXByte50;
	
	sizeSrc.cx = *((short*)(pCE2PtnS));
	sizeSrc.cy = *((short*)(pCE2PtnS+2));

	size50.cx =(sizeSrc.cx+1)/2;
	size50.cy =(sizeSrc.cy+1)/2;
	*((short*)(pCE2Ptn50))  = (short)size50.cx;
	*((short*)(pCE2Ptn50+2))= (short)size50.cy;
	
	if(size50.cx==0 || size50.cy==0) return 4;

	pCE2PtnS +=4;
	pCE2Ptn50+=4;

	nXByteS  =(sizeSrc.cx+7)/8;
	nXByte50 =(size50.cx+7)/8;
	
	BYTE buff[128];

	int y=0;
	int x;
	BYTE* pSrc;
	BYTE* pDst;


	do{
		for(x=0;x<nXByteS;x++)buff[x]=*pCE2PtnS++;
		y++;
		if(y<sizeSrc.cy) for(x=0;x<nXByteS;x++)buff[x]|=*pCE2PtnS++;
		y++;

		BYTE bSbit=0xC0;
		BYTE bDbit=0x80;
		pDst=pCE2Ptn50;
		pSrc=buff;
		*pDst=0;
		for(x=0;x<size50.cx;x++){
			if(*pSrc & bSbit) *pDst |= bDbit;
			if(bSbit<=0x3){
				bSbit=0xC0;
				pSrc++;
			}else{
				bSbit>>=2;
			}
			if(bDbit<=0x1){
				bDbit=0x80;
				pDst++;
				*pDst=0;
			}else{
				bDbit>>=1;
			}
		}
		pCE2Ptn50+=nXByte50;
	}while(y<sizeSrc.cy);

	return 4 + nXByte50 * size50.cy;
}


///////////////////////////////////////////////////////////
//			rbgp^[ 20% k
// CE2Cũp^[̃oCgԂ
static int ptn20(BYTE* pCE2PtnS,BYTE* pCE2Ptn20)
{
	CSize sizeSrc;
	CSize size20;
	int nXByteS;
	int nXByte20;
	
	sizeSrc.cx = *((short*)(pCE2PtnS));
	sizeSrc.cy = *((short*)(pCE2PtnS+2));

	size20.cx =(sizeSrc.cx+4)/5;
	size20.cy =(sizeSrc.cy+4)/5;
	*((short*)(pCE2Ptn20))  = (short)size20.cx;
	*((short*)(pCE2Ptn20+2))= (short)size20.cy;

	
	if(size20.cx==0 || size20.cy==0) return 4;

	pCE2PtnS +=4;
	pCE2Ptn20+=4;

	nXByteS  =(sizeSrc.cx+7)/8;
	nXByte20 =(size20.cx+7)/8;
	
	BYTE buff[128];

	int y=0;
	int x;
	BYTE* pSrc;
	BYTE* pDst;


	do{
		//TOR
		for(x=0;x<nXByteS;x++)buff[x]=*pCE2PtnS++;
		y++;
		int i;
		for(i=0;i<4;i++){
			if(y>=sizeSrc.cy) break;
			for(x=0;x<nXByteS;x++)buff[x]|=*pCE2PtnS++;
			y++;
		}
		//ThbgOR
		BYTE bSbit=0x80;
		int  nXsrc=0;	//ThbgOR̂߂̉hbgJE^
		int  n;			//TOR̃JEg
		BYTE bDbit=0x80;
		pDst=pCE2Ptn20;
		pSrc=buff;
		*pDst=0;
		for(x=0;x<size20.cx;x++){
			for(n=0;n<5;n++){
				if(nXsrc>=sizeSrc.cx) break;
				nXsrc++;
				if(*pSrc & bSbit) *pDst |= bDbit;
				if(bSbit==0x01){
					bSbit=0x80;
					pSrc++;
				}else{
					bSbit>>=1;
				}
			}
			if(bDbit==0x01){
				bDbit=0x80;
				pDst++;
				*pDst=0;
			}else{
				bDbit>>=1;
			}
		}
		pCE2Ptn20+=nXByte20;
	}while(y<sizeSrc.cy);

	return 4 + nXByte20 * size20.cy;
}


BOOL CLCoData::SetPtn()
{
	POSITION pos;
	pos=m_listPtn.GetHeadPosition();
	int n=0;
	while(pos){
		CLCoPtn* pPtn=m_listPtn.GetNext(pos);
		int nTextOffset=RegisterWord(pPtn->m_strName);
		pwPtnNameIndex[n]   =(int)nTextOffset;

		//100%p^[̓o^
		BYTE* pPtn100= pPtnArea+nBytePtnArea;
		int nSizePtn= LCoPtnToCE2Ptn(pPtn,pBuffTmp);
		if(nSizePtn+nBytePtnArea >0x64000) return FALSE;
		memcpy(pPtn100,pBuffTmp,nSizePtn);
		pwPtnIndex[n*3] =(WORD)nBytePtnArea;
		//TRACE("    100:  %d\n",nBytePtnArea);
		nBytePtnArea+=nSizePtn;
		
		//50%p^[̓o^
		nSizePtn= ptn50(pPtn100,pBuffTmp);
		if(nSizePtn+nBytePtnArea >0x64000) return FALSE;
		memcpy(pPtnArea+nBytePtnArea,pBuffTmp,nSizePtn);
		pwPtnIndex[n*3+1] =(WORD)nBytePtnArea;
		//TRACE("     50:  %d\n",nBytePtnArea);
		nBytePtnArea+=nSizePtn;

		//20%p^[̓o^
		nSizePtn= ptn20(pPtn100,pBuffTmp);
		if(nSizePtn+nBytePtnArea >0x64000) return FALSE;
		memcpy(pPtnArea+nBytePtnArea,pBuffTmp,nSizePtn);
		pwPtnIndex[n*3+2] =(WORD)nBytePtnArea;
		//TRACE("     20:  %d\n",nBytePtnArea);
		nBytePtnArea+=nSizePtn;
		n++;
	}
	return TRUE;
}

//p^[̃CfbNX𓾂
int CLCoData::GetPtnIndex(CLCoPtn* pPtn)
{
	POSITION pos;
	pos=m_listPtn.GetHeadPosition();
	int n=0;
	while(pos){
		CLCoPtn* pPtnS=m_listPtn.GetNext(pos);
		if(pPtnS==pPtn) return n;
		n++;
	}
	return -1;
}

//iGAւ̕ĩZbg
BOOL CLCoData::SetPartArea()
{
	int nOffset;
	POSITION pos=m_listPartInfo.GetHeadPosition();
	CE2PartInfo* pCE2Part=(CE2PartInfo*)pBuffTmp;
	int nPartCount=0;
	while(pos){
		CLCoPartInfo* pLCoPart=m_listPartInfo.GetNext(pos);
		//TCY̐ݒ
		pCE2Part->bX=(BYTE)pLCoPart->m_size.cx;
		pCE2Part->bY=(BYTE)pLCoPart->m_size.cy;
		//ubN̐ݒ
		pCE2Part->bDev=(BYTE)pLCoPart->m_nBlock;
		//U[uGÂONA
		pCE2Part->bres[0]=pCE2Part->bres[1]=pCE2Part->bres[2]=0;
		//vtBbNX̐ݒ
		nOffset=RegisterWord(pLCoPart->m_strPrefix);
		if(nOffset<0) return FALSE;
		pCE2Part->wPrefix=(WORD)nOffset;
		//p^[̐ݒ
		if(pLCoPart->m_pPtn==NULL) pCE2Part->wPtn=0xFFFF;
		else  pCE2Part->wPtn=(WORD)GetPtnIndex(pLCoPart->m_pPtn);
		//***** pCE2Part->wPinInfo ͌ʃsݒɊm肷邱ƂɂȂ *****
		int nPinCount=pLCoPart->m_listPin.GetCount();
		pCE2Part->wPinInfo =nPinCount & 0x0FFF;
		int	nCE2PinSize;
		//ʃsݒ
		if(nPinCount!=0){
			CE2PinInfo* pCE2Pin=(CE2PinInfo*)(((BYTE*)pCE2Part)+sizeof(CE2PartInfo));
			nCE2PinSize=4+2*pCE2Part->bDev;		// pCE2PiñTCY
			POSITION posPin=pLCoPart->m_listPin.GetHeadPosition();
			while(posPin){
				CLCoPin* pLCoPin=pLCoPart->m_listPin.GetNext(posPin);
				//s̃Xe[^X̐ݒ
				pCE2Pin->wStatus=(WORD)(pLCoPin->m_nOffset) & 0xFF;
				switch(pLCoPin->m_nLTRB){
				case 0:	// L
					pCE2Pin->wStatus	|= 0x0000;
					pCE2Part->wPinInfo	|= 0x8000;
					break;
				case 1: // T
					pCE2Pin->wStatus	|= 0x0100;
					pCE2Part->wPinInfo	|= 0x4000;
					break;
				case 2: // R
					pCE2Pin->wStatus	|= 0x0200;
					pCE2Part->wPinInfo	|= 0x2000;
					break;
				case 3: // B
					pCE2Pin->wStatus	|= 0x0300;
					pCE2Part->wPinInfo	|= 0x1000;
					break;
				}
				if(pLCoPin->m_nType & PIN_TYPE_SMALL)	 pCE2Pin->wStatus |= 0x1000;
				if(pLCoPin->m_nType & PIN_TYPE_CLOCK)	 pCE2Pin->wStatus |= 0x4000;
				if(pLCoPin->m_nType & PIN_TYPE_NEGATIVE) pCE2Pin->wStatus |= 0x8000;
				//s̐ݒ
				if(pLCoPin->m_strName.IsEmpty())	pCE2Pin->wName=0xFFFF;
				else{
					nOffset=RegisterPinNameAsPascalWord(pLCoPin->m_strName);
					if(nOffset<0) return FALSE;
					pCE2Pin->wName=nOffset;
				}
				int i;
				for(i=0;i<pCE2Part->bDev;i++){
					BOOL bNotHide=(pLCoPin->m_pstrPinNum[i][0]!='H');
					CString str;
					if(pLCoPin->m_pstrPinNum[i][0]=='\0'){
						str="";
					}else{
						str=pLCoPin->m_pstrPinNum[i].Mid(1);
					}
					DWORD dwNum = g_szPinTodwPin(str,bNotHide);
					//pCE2Pin->arywNum[i]=(WORD)(pLCoPin->m_pdwNum[i]);
					pCE2Pin->arywNum[i]=(WORD)(dwNum);
				}
				pCE2Pin=(CE2PinInfo*)(((BYTE*)pCE2Pin)+nCE2PinSize);
			}
		}
		int nCE2PartInfoSize=sizeof(CE2PartInfo)+ nCE2PinSize * nPinCount;
		if(nBytePartArea+nCE2PartInfoSize >64000) return FALSE;
		memcpy(pPartArea+nBytePartArea,pCE2Part,nCE2PartInfoSize);
		warrayCE2Part[nPartCount]=(WORD)nBytePartArea;
		nBytePartArea+=nCE2PartInfoSize;
		nPartCount++;
	}

	return TRUE;
}


//iijCfbNX̃Zbg
BOOL CLCoData::SetPartIndex()
{
	POSITION pos=m_listPartIndex.GetHeadPosition();
	int n=0;	//CfbNX̃JE^Ɏgp
	int m;		//i񌟍̃JE^ƂĎgp
	while(pos){
		CLCoPartIndex*	pPartIndex=m_listPartIndex.GetNext(pos);
		//i̐ݒ
		int nOffset=RegisterWord(pPartIndex->m_strName);
		if(nOffset<0) return FALSE;
		pdwNameIndex[n]=nOffset;
		//ĩItZbgݒ
		POSITION posPartInfo=m_listPartInfo.GetHeadPosition();
		m=0;
		while(posPartInfo){
			CLCoPartInfo* pPartInfo=m_listPartInfo.GetNext(posPartInfo);
			if(pPartInfo==pPartIndex->m_pPartInfo){
				pwPartIndex[n]=warrayCE2Part[m];
				break;
			}
			m++;
			if(!posPartInfo) return FALSE;	//v镔i񂪌Ȃ
		}
		n++;
	}
	return TRUE;
}


//CECȕ
BOOL CLCoData::WriteCeLibrary(LPCSTR pszFilename)
{
	CFile file;
	int nTotalSize=0;
	TRACE("CLCoData::WriteCeLibrary()\n");
	BOOL bResult=FALSE;
	int  nErrCode=0;



	ClearListWord();
	ClearListPascalWord();
	warrayCE2Part=new WORD[m_listPartInfo.GetCount()];

	int nPart=m_listPartIndex.GetCount();
	pdwNameIndex=new DWORD[nPart];
	pwPartIndex =new WORD[nPart];
	pPartArea   =new BYTE[64000];
	nBytePartArea=0;
	int nPtn=m_listPtn.GetCount();
	pwPtnIndex		=new WORD[nPtn*3];	
	pwPtnNameIndex  =new WORD[nPtn];
	pPtnArea	=new BYTE[64000];
	nBytePtnArea=0;
	pTextArea	=new char[64000];
	nByteTextArea=0;
	pBuffTmp	=new BYTE[32000];

	//p^[GAƃp^[CfbNXGA̐ݒ
	if(!SetPtn()){
		nErrCode=1;
		goto ENDOFFUNC;
	}
	//i`GA̐ݒ
	if(!SetPartArea()){
		nErrCode=1;
		goto ENDOFFUNC;
	}
	//iCfbNXƕiCfbNX̐ݒ
	if(!SetPartIndex()){
		nErrCode=2;
		goto ENDOFFUNC;
	}
	//Ŝ̃TCY̊mFs
	nTotalSize=
		  54			//wb_[
		+ 4 * nPart		//iCfbNX̃TCY
		+ 2 * nPart		//iCfbNX̃TCY
		+ nBytePartArea //i`GÃTCY
		+ 8 * nPtn		//p^[CfbNX̃TCY
		+ nBytePtnArea	//p^[GÃTCY
		+ nByteTextArea;//eLXgGÃTCY

	//TCY𒴂Ƃ̓G[R[hZbg
	//֐̏IցB
	if(nTotalSize>0xFFFE){
		nErrCode=1;
		goto ENDOFFUNC;
	}

	//obNAbvt@C̍쐬
    char szBackPath[_MAX_PATH];
	char szBackDrive[_MAX_DRIVE];
	char szBackDir[_MAX_DIR];
	char szBackFname[_MAX_FNAME];
	char szBackExt[_MAX_EXT];
	_splitpath(pszFilename,szBackDrive,szBackDir,szBackFname,szBackExt);
	_makepath(szBackPath,szBackDrive,szBackDir,szBackFname,".$ib");
	remove(szBackPath);
	rename(pszFilename,szBackPath);

	//t@Cւ̏
	if(file.Open(pszFilename,CFile::modeWrite|CFile::modeCreate)){
		//wb_[̏
		CE2LibHeader ce2Header;
		lstrcpy(ce2Header.szId,g_szLibraryID);
		ce2Header.wPart=(WORD)nPart;
		int nOffset=54;
		ce2Header.dwPartNameIndex=nOffset;
		nOffset+=4 * nPart;
		ce2Header.dwPartIndex=nOffset;
		nOffset+=2 * nPart;
		ce2Header.dwPartArea=nOffset;
		nOffset+=nBytePartArea;
		ce2Header.dwPtnIndex=nOffset;
		nOffset+=8 * nPtn;
		ce2Header.dwPtnArea=nOffset;
		nOffset+=nBytePtnArea;
		ce2Header.dwTextArea=nOffset;
		//wb_[̏
		try{ file.Write(&ce2Header,54); }
		catch(CFileException *e){
			if(e->m_cause!=CFileException::none)nErrCode=3;
			e->Delete();
			if(nErrCode==3) goto ENDOFFUNC;
		}
	
		//iCfbNX̏
		try{ file.Write(pdwNameIndex,4*nPart); }
		catch(CFileException *e){
			if(e->m_cause!=CFileException::none)nErrCode=3;
			e->Delete();
			if(nErrCode==3) goto ENDOFFUNC;
		}
		//iCfbNX̏
		try{ file.Write(pwPartIndex,2*nPart); }
		catch(CFileException *e){
			if(e->m_cause!=CFileException::none)nErrCode=3;
			e->Delete();
			if(nErrCode==3) goto ENDOFFUNC;
		}
		//i`GȀ
		try{ file.Write(pPartArea,nBytePartArea); }
		catch(CFileException *e){
			if(e->m_cause!=CFileException::none)nErrCode=3;
			e->Delete();
			if(nErrCode==3) goto ENDOFFUNC;
		}
		//p^[CfbNX̏
		try{ file.Write(pwPtnIndex,6*nPtn); }
		catch(CFileException *e){
			if(e->m_cause!=CFileException::none)nErrCode=3;
			e->Delete();
			if(nErrCode==3) goto ENDOFFUNC;
		}
		//p^[CfbNX̏
		try{ file.Write(pwPtnNameIndex,2*nPtn); }
		catch(CFileException *e){
			if(e->m_cause!=CFileException::none)nErrCode=3;
			e->Delete();
			if(nErrCode==3) goto ENDOFFUNC;
		}
		//p^[GȀ
		try{ file.Write(pPtnArea,nBytePtnArea); }
		catch(CFileException *e){
			if(e->m_cause!=CFileException::none)nErrCode=3;
			e->Delete();
			if(nErrCode==3) goto ENDOFFUNC;
		}
		//eLXgGȀ
		try{ file.Write(pTextArea,nByteTextArea); }
		catch(CFileException *e){
			if(e->m_cause!=CFileException::none)nErrCode=3;
			e->Delete();
			if(nErrCode==3) goto ENDOFFUNC;
		}

		bResult=TRUE;
	}else{
		nErrCode=3;
	}
ENDOFFUNC:	
	delete[]pdwNameIndex;
	delete[]pwPartIndex;
	delete[]pPartArea;
	delete[]pwPtnIndex;
	delete[]pwPtnNameIndex;
	delete[]pPtnArea;
	delete[]pTextArea;
	delete[]pBuffTmp;
	ClearListWord();
	ClearListPascalWord();
	delete[]warrayCE2Part;

	int nIdMsg;
	if(nErrCode){
		switch(nErrCode){
		case 1: nIdMsg=IDS_TOOLARGE;	break;
		case 2: nIdMsg=IDS_DATAERR;		break;
		default: nIdMsg=IDS_WRERR;		break;
		}
		AfxMessageBox(nIdMsg);
	}
	return bResult;
}

BOOL CLCoData::WriteLb3PinInfo(SWriteCE3& wce3,const CLCoPin* pPin,int nBlock)
{
	char sz[32];
	const char szLTRB[]="LTRB";
	string str;
	
	if(EOF==wce3.WriteRecord("+PIN")) return FALSE;
	str = "N:";	str += pPin->m_strName;
	if(EOF==wce3.WriteRecord(str)) return FALSE;
	assert(pPin->m_nLTRB >= 0 && pPin->m_nLTRB <=3);
	sprintf(sz,"L:%c%d",szLTRB[pPin->m_nLTRB],pPin->m_nOffset);
	if(EOF==wce3.WriteRecord(sz)) return FALSE;
	int n=0;
	if(pPin->m_nType & PIN_TYPE_NEGATIVE)	sz[n++]='N';
	if(pPin->m_nType & PIN_TYPE_SMALL)		sz[n++]='S';
	if(pPin->m_nType & PIN_TYPE_CLOCK)		sz[n++]='C';
	if(pPin->m_pstrPinNum[0][0]=='H')		sz[n++]='m';
	sz[n]='\0';
	str = "T:";	str += sz;
	if(EOF==wce3.WriteRecord(str)) return FALSE;
	int i;
	for(i=0;i<nBlock;i++){
		str = "M:";  str +=  pPin->m_pstrPinNum[i].Mid(1);
		if(EOF==wce3.WriteRecord(str)) return FALSE;
	}
	if(EOF==wce3.WriteRecord("-PIN")) return FALSE;
	if(EOF==wce3.WriteEOL()) return FALSE;
	return TRUE;
}


BOOL CLCoData::WriteLb3PartInfo(SWriteCE3& wce3,const CLCoPartInfo* pPartInfo)
{
	char sz[32];
	string str;
	int block=pPartInfo->m_nBlock;
	sprintf(sz,"X:%d",pPartInfo->m_size.cx);
	if(EOF==wce3.WriteRecord(sz)) return FALSE;
	sprintf(sz,"Y:%d",pPartInfo->m_size.cy);
	if(EOF==wce3.WriteRecord(sz)) return FALSE;
	sprintf(sz,"B:%d",block);
	if(EOF==wce3.WriteRecord(sz)) return FALSE;
	if(EOF==wce3.WriteEOL()) return FALSE;
	str = "R:";	str += pPartInfo->m_strPrefix;
	if(EOF==wce3.WriteRecord(str)) return FALSE;
	if(EOF==wce3.WriteEOL()) return FALSE;
	if(pPartInfo->m_pPtn!=NULL){
		str="P:"; str+=pPartInfo->m_pPtn->m_strName;
		if(EOF==wce3.WriteRecord(str)) return FALSE;
		if(EOF==wce3.WriteEOL()) return FALSE;
	}
	POSITION pos=pPartInfo->m_listPin.GetHeadPosition();
	while(pos){
		CLCoPin* pPin=pPartInfo->m_listPin.GetNext(pos);
		if(!WriteLb3PinInfo(wce3,pPin,block)) return FALSE;
	}
	return TRUE;
}

BOOL CLCoData::WriteLb3Ptn(SWriteCE3& wce3,const CLCoPtn* pPtn)
{
	char sz[256];
	string str;
	
	if(EOF==wce3.WriteRecord("+PTN")) return FALSE;
	str = "N:";	str += pPtn->m_strName;
	if(EOF==wce3.WriteRecord(str)) return FALSE;
	sprintf(sz,"X:%d",pPtn->m_size.cx);
	if(EOF==wce3.WriteRecord(sz)) return FALSE;
	sprintf(sz,"Y:%d",pPtn->m_size.cy);
	if(EOF==wce3.WriteRecord(sz)) return FALSE;
	if(EOF==wce3.WriteEOL()) return FALSE;
	if(EOF==wce3.WriteRecord("+BMP")) return FALSE;
	if(EOF==wce3.WriteEOL()) return FALSE;
	int buffxbyte = ((pPtn->m_size.cx+15)/16)*2;
	int outxbyte = (pPtn->m_size.cx+7)/8;
	int x,y,i;
	for(y=0;y<pPtn->m_size.cy;y++){
		i=0;
		BYTE* puc=pPtn->m_pBuff + buffxbyte*y;
		for(x=0;x<outxbyte;x++){
			sz[i++]='@'+ ((*puc & 0xF0)>>4);
			sz[i++]='@'+ (*puc & 0x0F);
			puc++;
		}
		sz[i]='\0';
		if(EOF==wce3.WriteRecord(sz)) return FALSE;
		if(EOF==wce3.WriteEOL()) return FALSE;
	}
	if(EOF==wce3.WriteRecord("-BMP")) return FALSE;
	if(EOF==wce3.WriteEOL()) return FALSE;
	if(EOF==wce3.WriteRecord("-PTN")) return FALSE;
	if(EOF==wce3.WriteEOL()) return FALSE;
	return TRUE;
}

	
	




//LB3Cȕ
BOOL CLCoData::WriteLb3(LPCSTR pszFilename)
{
	FILE* fp;
	fp = fopen(pszFilename,"w");
	string str;
	if(fp==NULL) return FALSE;
	SWriteCE3 wce3;
	wce3.Attach(fp);
	POSITION pos;
	POSITION pos1;
	POSITION pos2;
	
	if(EOF==wce3.WriteRecord("+BSCH3_LIB_V.1.0")) goto WrErr;
	if(EOF==wce3.WriteEOL()) goto WrErr;

	pos= m_listPtn.GetHeadPosition();
	while(pos){
		CLCoPtn* pPtn = m_listPtn.GetNext(pos);	
		if(!WriteLb3Ptn(wce3,pPtn)) goto WrErr;
	}

	pos=m_listPartIndex.GetHeadPosition();
	while(pos){
		pos1=pos;
		CLCoPartIndex* pPartIndex=m_listPartIndex.GetNext(pos);
		//GCAX̃`FbN
		pos2=m_listPartIndex.GetHeadPosition();
		BOOL existAlias=FALSE;
		while(pos2 && pos2!=pos1){
			CLCoPartIndex* pPartIndex2=m_listPartIndex.GetNext(pos2);
			if(pPartIndex2->m_pPartInfo == pPartIndex->m_pPartInfo){
				existAlias=TRUE;
				if(EOF==wce3.WriteRecord("+ALIAS")) goto WrErr;
				str = "A:";	str += pPartIndex->m_strName;
				if(EOF==wce3.WriteRecord(str)) goto WrErr;
				str = "N:";	str += pPartIndex2->m_strName;
				if(EOF==wce3.WriteRecord(str)) goto WrErr;
				if(EOF==wce3.WriteRecord("-ALIAS")) goto WrErr;
				if(EOF==wce3.WriteEOL()) goto WrErr;
				break;
			}
		}
		if(!existAlias){	//GCAXȂꍇ
			if(EOF==wce3.WriteRecord("+COMP")) goto WrErr;
			str = "N:";
			str += pPartIndex->m_strName;
			if(EOF==wce3.WriteRecord(str)) goto WrErr;
			if(EOF==wce3.WriteEOL()) goto WrErr;

			if(!WriteLb3PartInfo(wce3,pPartIndex->m_pPartInfo)) goto WrErr;	

			if(EOF==wce3.WriteRecord("-COMP")) goto WrErr;
			if(EOF==wce3.WriteEOL()) goto WrErr;
		}
	}
	if(EOF==wce3.WriteRecord("-BSCH3_LIB_V.1.0")) goto WrErr;
	if(EOF==wce3.WriteEOL()) goto WrErr;
	

	fclose(fp);
	return TRUE;
WrErr:
	fclose(fp);
	return FALSE;
}




