// Find.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "bsch.h"
#include "BSchObj.h"
#include "PartLib.h"
#include "BSchPart.h"
#include "BSchTag.h"
#include "BSchLbl.h"
#include "BSchCmnt.h"

#include "BSchDoc.h"
#include "BSchView.h"


#include "Find.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFind _CAO


CFind::CFind(CWnd* pParent /*=NULL*/)
	: CDialog(CFind::IDD, pParent)
{
	m_pView	= NULL;
	m_bJump = FALSE;

	m_bSearchComplete	=TRUE;
	m_bSearchPartN		=TRUE;
	m_bSearchPartV		=TRUE;
	m_bSearchPartB		=TRUE;
	m_bSearchTag		=TRUE;
	m_bSearchLabel		=TRUE;
	m_bSearchComment	=TRUE;
	m_sizeDlg.cx		=0;
	//{{AFX_DATA_INIT(CFind)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void CFind::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFind)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}

CFind::~CFind()
{
	ClearFind();
}


BEGIN_MESSAGE_MAP(CFind, CDialog)
	//{{AFX_MSG_MAP(CFind)
	ON_BN_CLICKED(IDC_SEARCHTAG, OnSearchtag)
	ON_BN_CLICKED(IDC_SEARCHPARTV, OnSearchpartv)
	ON_BN_CLICKED(IDC_SEARCHPARTN, OnSearchpartn)
	ON_BN_CLICKED(IDC_SEARCHCOMMENT, OnSearchcomment)
	ON_BN_CLICKED(IDC_SEARCHLABEL, OnSearchlabel)
	ON_NOTIFY(NM_CLICK, IDC_LISTRESULT, OnClickListresult)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LISTRESULT, OnItemchangedListresult)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LISTRESULT, OnColumnclickListresult)
	ON_WM_GETMINMAXINFO()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_SEARCHNAMELIB, OnSearchnamelib)
	ON_BN_CLICKED(IDC_SEARCHCOMP, OnSearchcomp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



//str2str1܂܂TRUE
BOOL CFind::IsMatch(LPCSTR str1,LPCSTR str2)
{
	if(m_bSearchComplete){
		if(!lstrcmp(str1,str2)) return TRUE;
		else					return FALSE;
	}else{
		if(strstr(str1,str2))	return TRUE;
		else					return FALSE;
	}
}


/////////////////////////////////////////////////////////////////////////////
// CFind bZ[W nh

//OnOK͌{^Ɋ蓖ĂĂ
void CFind::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	TRACE("CFind::OnOK()\n");
	
	//ʂ̏
	ClearFind();

	//Xg{bNX̓ȅ
	CListCtrl* pList =(CListCtrl*)GetDlgItem(IDC_LISTRESULT);
	pList->DeleteAllItems();
	
	//̎擾
	CEdit* pedit=(CEdit*)GetDlgItem(IDC_FINDSTRING);
	CString str;
	pedit->GetWindowText(str);
	
	//f[^̌
	CBSchDoc* pDoc=m_pView->GetDocument();

	CObList* pMainData;
	int n;
	const char* psz;

	for(n=0;n<MAX_MAINDATA;n++){
		if((pMainData=pDoc->GetMainData(n))==NULL) break;	//Cf[^̃Xg͂܂
		POSITION pos =pMainData->GetHeadPosition();	//擪̗vf𓾂
		while(pos){
			CBSchObj* pObj=(CBSchObj*)pMainData->GetNext(pos);
			if(pObj->GetStus() & STUS_DELETE) continue;//|C^̗vff[^Ȃ牽Ȃ
			if(pObj->GetLayer() != pDoc->m_nEditLayer) continue;//ҏWC[̃f[^łȂΉȂ 1998/06/27
			
			switch(pObj->GetId()){
			case IDOBJ_PART:
				if(m_bSearchPartN){
					psz=((CBSchPart*)pObj)->GetPartNum();
					if(IsMatch(psz,str)){
						AddFindItem(pList,psz,pObj);
					}
				}
				if(m_bSearchPartV){
					psz=((CBSchPart*)pObj)->GetPartName();
					if(IsMatch(psz,str)){
						AddFindItem(pList,psz,pObj);
					}
				}
				if(m_bSearchPartB){
					CPartIndex* ppi=((CBSchPart*)pObj)->GetPartIndex();
					psz=ppi->GetName(NULL);
					if(IsMatch(psz,str)){
						AddFindItem(pList,psz,pObj);
					}
				}
				break;
			case IDOBJ_TAG:
				if(m_bSearchTag){
					psz=((CBSchTag*)pObj)->GetTagString();
					if(IsMatch(psz,str)){
						AddFindItem(pList,psz,pObj);
					}
				}
				break;
			case IDOBJ_LABEL:
				if(m_bSearchLabel){
					psz=((CBSchLabel*)pObj)->GetString();
					if(IsMatch(psz,str)){
						AddFindItem(pList,psz,pObj);
					}
				}
				break;
			case IDOBJ_COMMENT:
				if(m_bSearchComment){
					psz=((CBSchComment*)pObj)->GetString();
					if(IsMatch(psz,str)){
						AddFindItem(pList,psz,pObj);
					}
				}
				break;
			default:
				continue;
			}
		}
	}


	//CDialog::OnOK();
}


int CFind::AddFindItem(CListCtrl* pList,LPCSTR psz, CBSchObj* pObj)
{
	int nID=pObj->GetId();
	int nIcon;

	if(nID==IDOBJ_PART)				nIcon=0;
	else if(nID==IDOBJ_TAG)			nIcon=1;
	else if(nID==IDOBJ_LABEL)		nIcon=2;
	else if(nID==IDOBJ_COMMENT)		nIcon=3;
	else return -1;

	CFindData* pFind=new CFindData;
	pFind->m_psz = psz;
	pFind->m_pObj= pObj;
	m_listFind.AddTail(pFind);
	
	int newIndex=pList->InsertItem(0,psz,nIcon);
	CPoint pt=pObj->GetPoint();
	char sz[32];
	::_itoa(pt.x,sz,10);
	pList->SetItemText(newIndex,1,sz);
	::_itoa(pt.y,sz,10);
	pList->SetItemText(newIndex,2,sz);
	pList->SetItemData(newIndex,(DWORD)pFind);

	return newIndex;
}

void CFind::OnCancel() 
{
	// TODO: ̈ʒuɓʂȌ㏈ǉĂB
	TRACE("CFind::OnCancel()\n");

	AfxGetApp()->WriteProfileInt("Search","Complete",m_bSearchComplete);
	AfxGetApp()->WriteProfileInt("Search","PartNum",m_bSearchPartN);
	AfxGetApp()->WriteProfileInt("Search","PartVal",m_bSearchPartV);
	AfxGetApp()->WriteProfileInt("Search","PartLibName",m_bSearchPartB);
	AfxGetApp()->WriteProfileInt("Search","Tag",m_bSearchTag);
	AfxGetApp()->WriteProfileInt("Search","Label",m_bSearchLabel);
	AfxGetApp()->WriteProfileInt("Search","Comment",m_bSearchComment);

	CDialog::OnCancel();
}



void CFind::OnSearchcomp() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CButton* pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHCOMP);
	m_bSearchComplete=pbtn->GetCheck();
}

/////////////////////////////////////////////////////////////////////
//  OnSearch***()͌Ώۂw肷`FbN{bNX
//  ̑ɂƂȂnhB
//  S̃`FbN͊OȂB
void CFind::OnSearchtag() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CButton* pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHTAG);
	m_bSearchTag=pbtn->GetCheck();
	SetSearchButtonEnable();
/*
	if(		!m_bSearchPartN
		&&	!m_bSearchPartV
		&&	 m_bSearchTag
		&&	!m_bSearchLabel
		&&	!m_bSearchComment
		){
		pbtn->SetCheck(TRUE);
	}else{
		m_bSearchTag=pbtn->GetCheck();
	}	*/
}

void CFind::OnSearchpartv() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CButton* pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHPARTV);
	m_bSearchPartV=pbtn->GetCheck();
	SetSearchButtonEnable();
/*
	if(		!m_bSearchPartN
		&&	 m_bSearchPartV
		&&	!m_bSearchTag
		&&	!m_bSearchLabel
		&&	!m_bSearchComment
	){
		pbtn->SetCheck(TRUE);
	}else{
		m_bSearchPartV=pbtn->GetCheck();
	}*/
}

void CFind::OnSearchpartn() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CButton* pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHPARTN);
	m_bSearchPartN=pbtn->GetCheck();
	SetSearchButtonEnable();
/*
	if(		 m_bSearchPartN
		&&	!m_bSearchPartV
		&&	!m_bSearchTag
		&&	!m_bSearchLabel
		&&	!m_bSearchComment
	){
		pbtn->SetCheck(TRUE);
	}else{
		m_bSearchPartN=pbtn->GetCheck();
	}*/
}

void CFind::OnSearchnamelib() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CButton* pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHNAMELIB);
	m_bSearchPartB=pbtn->GetCheck();
	SetSearchButtonEnable();
}


void CFind::OnSearchcomment() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CButton* pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHCOMMENT);
	m_bSearchComment=pbtn->GetCheck();
	SetSearchButtonEnable();
/*
	if(		!m_bSearchPartN
		&&	!m_bSearchPartV
		&&	!m_bSearchTag
		&&	!m_bSearchLabel
		&&	 m_bSearchComment
	){
		pbtn->SetCheck(TRUE);
	}else{
		m_bSearchComment=pbtn->GetCheck();
	}*/
}

void CFind::OnSearchlabel() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CButton* pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHLABEL);
	m_bSearchLabel=pbtn->GetCheck();
	SetSearchButtonEnable();
/*
	if(		!m_bSearchPartN
		&&	!m_bSearchPartV
		&&	!m_bSearchTag
		&&	 m_bSearchLabel
		&&	!m_bSearchComment
	){
		pbtn->SetCheck(TRUE);
	}else{
		m_bSearchLabel=pbtn->GetCheck();
	} */
}

BOOL CFind::OnInitDialog() 
{
	HICON hIcon[4];
	CString strHeader;
	int n;

	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ

	HICON hIconApp=AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	SetIcon(hIconApp, FALSE);			// ACRݒ

	//C[WXg̏
	m_imagelist.Create(16,16,0,4,4);
	m_imagelist.SetBkColor(RGB(255,255,255));
	hIcon[0] = AfxGetApp()->LoadIcon(IDI_PART);
	hIcon[1] = AfxGetApp()->LoadIcon(IDI_TAG);
	hIcon[2] = AfxGetApp()->LoadIcon(IDI_LABEL);
	hIcon[3] = AfxGetApp()->LoadIcon(IDI_COMMENT);
	for(n=0;n<4;n++){
		m_imagelist.Add(hIcon[n]);
	}

	//static char* psz[]={"PART","TAG","LABEL","COMMENT"};

	//ʃXg{bNX̏
	CListCtrl* pList =(CListCtrl*)GetDlgItem(IDC_LISTRESULT);
	pList->SetBkColor(RGB(255,255,255));
	int nLetterWidth = LOWORD(::GetDialogBaseUnits());
	strHeader.LoadString(IDS_FINDDLG_STRING);
	pList->InsertColumn(0,strHeader,LVCFMT_LEFT,nLetterWidth*30,-1);
	strHeader.LoadString(IDS_FINDDLG_X);
	pList->InsertColumn(1,strHeader,LVCFMT_LEFT,nLetterWidth*6,1);
	strHeader.LoadString(IDS_FINDDLG_Y);
	pList->InsertColumn(2,strHeader,LVCFMT_LEFT,nLetterWidth*6,2);

	pList->SetImageList(&m_imagelist,LVSIL_SMALL);//C[WXg̐ݒ

	// IΏۃ`FbN{bNX̐ݒ
	m_bSearchComplete	=AfxGetApp()->GetProfileInt("Search","Complete",TRUE);
	m_bSearchPartN		=AfxGetApp()->GetProfileInt("Search","PartNum",TRUE);
	m_bSearchPartV		=AfxGetApp()->GetProfileInt("Search","PartVal",TRUE);
	m_bSearchPartB		=AfxGetApp()->GetProfileInt("Search","PartLibName",TRUE);
	m_bSearchTag		=AfxGetApp()->GetProfileInt("Search","Tag",TRUE);
	m_bSearchLabel		=AfxGetApp()->GetProfileInt("Search","Label",TRUE);
	m_bSearchComment	=AfxGetApp()->GetProfileInt("Search","Comment",TRUE);


	CButton* pbtn;
	pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHCOMP);
	pbtn->SetCheck(m_bSearchComplete);

	pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHPARTN);
	pbtn->SetCheck(m_bSearchPartN);

	pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHPARTV);
	pbtn->SetCheck(m_bSearchPartV);

	pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHNAMELIB);
	pbtn->SetCheck(m_bSearchPartB);


	pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHTAG);
	pbtn->SetCheck(m_bSearchTag);

	pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHLABEL);
	pbtn->SetCheck(m_bSearchLabel);

	pbtn=(CButton*)this->GetDlgItem(IDC_SEARCHCOMMENT);
	pbtn->SetCheck(m_bSearchComment);

	SetSearchButtonEnable();
	
	//WvtÕNA
	m_bJump=FALSE;

	CRect rc1;
	CRect rc2;

	GetWindowRect(&rc1);
	m_sizeDlg.cx = rc1.right-rc1.left;	//_CAȌTCY
	m_sizeDlg.cy = rc1.bottom-rc1.top;

	GetClientRect(&rc1);
	pList->GetWindowRect(&rc2);
	ScreenToClient(&rc2);
	m_nlv_t = rc2.top;					//Xgr[̏[W
	m_nlv_l = rc2.left;					//Xgr[̍[W
	m_nlv_b = rc1.bottom-rc2.bottom;	//Xgr[̃_CAO[̈ʒu
	m_nlv_r = rc1.right-rc2.right;		//Xgr[̃_CAOE[̈ʒu


	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CFind::OnClickListresult(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	NMLISTVIEW* lpnmlv = (LPNMLISTVIEW)pNMHDR;
	

	TRACE("CFind::OnClickListresult   %d\n",lpnmlv->iItem);

	*pResult = 0;
}


void CFind::OnItemchangedListresult(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CListCtrl* pList =(CListCtrl*)GetDlgItem(IDC_LISTRESULT);
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	if(pNMListView->uNewState & LVIS_SELECTED){
		CFindData* pFind=(CFindData*)pList->GetItemData(pNMListView->iItem);
		if(!pFind) return;
		//CBSchObj* pObj=(CBSchObj*)pList->GetItemData(pNMListView->iItem);
		CBSchObj* pObj=pFind->m_pObj;
		if(!pObj) return;
		m_ptJump=pObj->GetPoint();
		m_pView->JumpTo(&m_ptJump);
		m_bJump=TRUE;
	}
	*pResult = 0;
}

void CFind::ClearFind()
{
	TRACE("void CFind::ClearFind()\n");
	POSITION pos;
	pos=m_listFind.GetHeadPosition();
	while(pos){
		CFindData* pFind=(CFindData*)(m_listFind.GetNext(pos));
		delete pFind;
	}
	m_listFind.RemoveAll();
}


int CALLBACK CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	CPoint pt1;
	CPoint pt2;
	//int	nId1;
	//int	nId2;


	CFindData* pFind1=(CFindData*)lParam1;
	CFindData* pFind2=(CFindData*)lParam2;
	switch(lParamSort){
	case 0:
		//nId1 = pFind1->m_pObj->GetId();
		//nId2 = pFind2->m_pObj->GetId();
		//if(nId1==nId2)	return lstrcmp(pFind1->m_psz,pFind2->m_psz);
		//else return nId2-nId1;
		return lstrcmp(pFind1->m_psz,pFind2->m_psz);
	case 1:
	case 2:
		pt1=pFind1->m_pObj->GetPoint();
		pt2=pFind2->m_pObj->GetPoint();
		if(lParamSort==1)	return pt1.x-pt2.x;
		else				return pt1.y-pt2.y;
	}
	return 0;
}


void CFind::OnColumnclickListresult(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CListCtrl* pList =(CListCtrl*)GetDlgItem(IDC_LISTRESULT);
	pList->SortItems(CompareFunc,pNMListView->iSubItem);
	*pResult = 0;
}

BOOL CFind::SetSearchButtonEnable()
{
	CButton* pbtn;
	pbtn=(CButton*)this->GetDlgItem(IDOK);

	if(		!m_bSearchPartN
		&&	!m_bSearchPartV
		&&	!m_bSearchPartB
		&&	!m_bSearchTag
		&&	!m_bSearchLabel
		&&	!m_bSearchComment
	){
		pbtn->EnableWindow(FALSE);
		return FALSE;
	}else{
		pbtn->EnableWindow(TRUE);
		return TRUE;
	}
}

void CFind::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(m_sizeDlg.cx!=0){
		lpMMI->ptMaxTrackSize.x = m_sizeDlg.cx;
		lpMMI->ptMinTrackSize.x = m_sizeDlg.cx;
		lpMMI->ptMinTrackSize.y = m_sizeDlg.cy;
	}
	CDialog::OnGetMinMaxInfo(lpMMI);
}

void CFind::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if(m_sizeDlg.cx!=0){
		CListCtrl* pList =(CListCtrl*)GetDlgItem(IDC_LISTRESULT);
		CRect rc; 
		rc.top		= m_nlv_t;		//Xgr[̏[W
		rc.left		= m_nlv_l;		//Xgr[̍[W
		rc.bottom	= cy - m_nlv_b;	//Xgr[̉[W
		rc.right	= cx - m_nlv_r;	//Xgr[̉E[W
		pList->MoveWindow(&rc);
	}
}



