// PtnEd.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "LCo.h"
#include "PartInfo.h"
#include "PEditor.h"
#include "PtnEd.h"
#include "RnPtn.h"
#include "PtnSize.h"


//LCoDlg.h̃CN[ĥ߂...
#include "ColList.h"
#include "LCoData.h"
#include "PartView.h"
#include "LCoDlg.h"

#include "UsePtn.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPtnEd _CAO


CPtnEd::CPtnEd(CWnd* pParent /*=NULL*/)
	: CDialog(CPtnEd::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPtnEd)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
	m_hAccel=NULL;
	m_bCloseFlag=FALSE;
	m_sizeFrameMin=CSize(0,0);
	m_sizeClient=CSize(0,0);
	m_pListPtn=NULL;
	m_pPtnOnInit=NULL;
	m_bChange=FALSE;
}


void CPtnEd::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPtnEd)
                //  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPtnEd, CDialog)
	//{{AFX_MSG_MAP(CPtnEd)
	ON_WM_SIZE()
	ON_WM_GETMINMAXINFO()
	ON_WM_CLOSE()
	ON_CBN_SELCHANGE(IDC_COMBO_PTN, OnSelchangeComboPtn)
	ON_COMMAND(ID_ZOOMIN, OnZoomin)
	ON_COMMAND(ID_ZOOMOUT, OnZoomout)
	ON_COMMAND(ID_PTNEDIT_SELECT, OnPtneditSelect)
	ON_COMMAND(ID_PTNEDIT_PEN, OnPtneditPen)
	ON_COMMAND(ID_PTNEDIT_LINE, OnPtneditLine)
	ON_WM_INITMENU()
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_CLEAR, OnEditClear)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_PTNEDIT_CIRCLE, OnPtneditCircle)
	ON_COMMAND(ID_EDITPTN_RENAME, OnEditptnRename)
	ON_COMMAND(ID_EDITPTN_NEW, OnEditptnNew)
	ON_COMMAND(ID_EDITPTN_ATTRIBUTE, OnEditptnAttribute)
	ON_COMMAND(ID_EDITPTN_DEL, OnEditptnDel)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPtnEd bZ[W nh

BOOL CPtnEd::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_hAccel=::LoadAccelerators(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDR_ACCEL_PTNED));
	//ACR̐ݒ
	HICON hIcon=AfxGetApp()->LoadIcon(IDI_SMALL);
	SetIcon(hIcon, FALSE);			// ACRݒ

	//EChETCYlȉɂȂ߂Ɏg m_sizeMin ̐ݒ
	CRect rc;
	GetWindowRect(&rc);
	m_sizeFrameMin.cx=rc.right-rc.left;
	m_sizeFrameMin.cy=rc.bottom-rc.top;
	//NCAgTCY̏lm_sizeClientɐݒ
	GetClientRect(&rc);
	m_sizeClient.cx=rc.right;
	m_sizeClient.cy=rc.bottom;

	CComboBox* pCombo=(CComboBox*)GetDlgItem(IDC_COMBO_PTN);
	pCombo->GetWindowRect(&rc);
	ScreenToClient(&rc);

	//c[o[̏
	#define N_BUTTON 4	//rbg}bvŒ`{^̐
	m_wndToolBar.Create(WS_CHILD|WS_VISIBLE|CCS_NORESIZE|CCS_NODIVIDER,
		CRect(rc.right+4,rc.top-2,(rc.right+4)+24*N_BUTTON+4,rc.top+24),
		this,ID_PTNED_TOOLBAR);

	m_wndToolBar.AddBitmap(N_BUTTON,IDR_TOOL_PTNEDIT);
	TBBUTTON tbb[N_BUTTON];

	tbb[0].iBitmap		=0;
	tbb[0].idCommand	=ID_PTNEDIT_SELECT;
	tbb[0].fsState		=TBSTATE_ENABLED|TBSTATE_PRESSED;		//ꂾꂽԂ
	tbb[0].fsStyle		=TBSTYLE_BUTTON;
	tbb[0].dwData		=0;
	tbb[0].iString		=NULL;

	tbb[1].iBitmap		=1;
	tbb[1].idCommand	=ID_PTNEDIT_PEN;
	tbb[1].fsState		=TBSTATE_ENABLED;
	tbb[1].fsStyle		=TBSTYLE_BUTTON;
	tbb[1].dwData		=0;
	tbb[1].iString		=NULL;

	tbb[2].iBitmap		=2;
	tbb[2].idCommand	=ID_PTNEDIT_LINE;
	tbb[2].fsState		=TBSTATE_ENABLED;
	tbb[2].fsStyle		=TBSTYLE_BUTTON;
	tbb[2].dwData		=0;
	tbb[2].iString		=NULL;

	tbb[3].iBitmap		=3;
	tbb[3].idCommand	=ID_PTNEDIT_CIRCLE;
	tbb[3].fsState		=TBSTATE_ENABLED;
	tbb[3].fsStyle		=TBSTYLE_BUTTON;
	tbb[3].dwData		=0;
	tbb[3].iString		=NULL;

	m_wndToolBar.AddButtons(N_BUTTON,tbb);

	

	CRect rcToolBar;
	m_wndToolBar.GetWindowRect(&rcToolBar);
	ScreenToClient(&rcToolBar);

	

	CString strClassName;

	strClassName=AfxRegisterWndClass(
		CS_VREDRAW|CS_HREDRAW,
		AfxGetApp()->LoadStandardCursor(IDC_ARROW), 
		(HBRUSH)GetStockObject(LTGRAY_BRUSH));	//wi͖邢D


	m_wndPEditor.CreateEx(
		WS_EX_CLIENTEDGE,
		strClassName,
		"&Ptneditor",		//&PɈӖ
		WS_CHILD | WS_VISIBLE | WS_VSCROLL |WS_HSCROLL|WS_TABSTOP,
		0,0,0,0,
		this->m_hWnd,
		(HMENU)IDC_PEDITOR);

	SetItemSize();

	char sz[64];
	//p^[̃R{{bNX̐ݒ
	if(m_pListPtn){
		POSITION pos=m_pListPtn->GetHeadPosition();
		while(pos){
			CLCoPtn* pPtn=m_pListPtn->GetNext(pos);
			wsprintf(sz,"%dx%d  %s",pPtn->m_size.cx/10,pPtn->m_size.cy/10,pPtn->m_strName);
			int nIndex=pCombo->AddString(sz);
			pCombo->SetItemDataPtr(nIndex,pPtn);
		}
		int nCount=m_pListPtn->GetCount();
		if(nCount){
			if(m_pPtnOnInit){
				int n=0;
				while(n<nCount){
					if((CLCoPtn*)(pCombo->GetItemDataPtr(n))==m_pPtnOnInit){
						pCombo->SetCurSel(n);
						m_wndPEditor.SetPtnPtr(m_pPtnOnInit);
						break;
					}
					n++;
				}
			}else{
				pCombo->SetCurSel(0);
				CLCoPtn* pPtn=(CLCoPtn*)pCombo->GetItemDataPtr(0);
				m_wndPEditor.SetPtnPtr(pPtn);
			}
		}
	}

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

BOOL CPtnEd::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
		if(m_hAccel){
		if(::TranslateAccelerator(m_hWnd,m_hAccel,pMsg)) return TRUE;
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CPtnEd::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if(m_sizeFrameMin.cx==0) return;
	m_sizeClient.cx=cx;
	m_sizeClient.cy=cy;
	SetItemSize();
}

void CPtnEd::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	if(m_sizeFrameMin.cx==0) return;
	lpMMI->ptMinTrackSize.x=m_sizeFrameMin.cx;
	lpMMI->ptMinTrackSize.y=m_sizeFrameMin.cy;
	//CDialog::OnGetMinMaxInfo(lpMMI);
}


void CPtnEd::SetItemSize()
{
	CRect rc1;
	CRect rc2;
	//j[Ƃ̎d؂̃Zp[^
	CStatic* pSeparator=(CStatic*)GetDlgItem(IDC_SEPARATOR1);
	pSeparator->GetWindowRect(&rc1);
	ScreenToClient(&rc1);
	pSeparator->MoveWindow(0,0,m_sizeClient.cx,rc1.bottom-rc1.top);

	CWnd* pWnd=GetDlgItem(IDC_COMBO_PTN);
	pWnd->GetWindowRect(&rc1);
	ScreenToClient(&rc1);

	m_wndToolBar.GetWindowRect(&rc2);
	ScreenToClient(&rc2);

	int ntop;
	if(rc2.bottom>rc1.bottom) ntop=rc2.bottom; else ntop=rc1.bottom;
	ntop+=3;

	m_wndPEditor.MoveWindow(4,ntop,
		m_sizeClient.cx-8,m_sizeClient.cy-4-ntop);
}


void CPtnEd::OnCancel() 
{
	// TODO: ̈ʒuɓʂȌ㏈ǉĂB
	TRACE("CPtnEd::OnCancel()\n");
	if(m_bCloseFlag) CDialog::OnCancel();
}

void CPtnEd::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	TRACE("CPtnEd::OnClose()\n");
	m_bCloseFlag=TRUE;
	m_bChange|=m_wndPEditor.m_bChange;
	CDialog::OnClose();
}

void CPtnEd::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	//^[L[ŉNȂ悤ɂB
	return;
	//CDialog::OnOK();
}



void CPtnEd::OnSelchangeComboPtn() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CComboBox* pCombo=(CComboBox*)GetDlgItem(IDC_COMBO_PTN);
	int nIndex=pCombo->GetCurSel();
	CLCoPtn* pPtn=(CLCoPtn*)pCombo->GetItemDataPtr(nIndex);
	m_wndPEditor.SetPtnPtr(pPtn);
}

void CPtnEd::OnZoomin() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_wndPEditor.ZoomIn();
	
}

void CPtnEd::OnZoomout() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_wndPEditor.ZoomOut();
	
}


//c[o[̃{^̐ݒ
void CPtnEd::SetToolButton(int nID)
{
	static const int arraynID[N_BUTTON]={	ID_PTNEDIT_SELECT,
											ID_PTNEDIT_PEN,
											ID_PTNEDIT_LINE,
											ID_PTNEDIT_CIRCLE
										};
	int n;
	for(n=0;n<N_BUTTON;n++)
		m_wndToolBar.PressButton(arraynID[n],arraynID[n]==nID);
}

void CPtnEd::OnPtneditSelect() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	SetToolButton(ID_PTNEDIT_SELECT);
	m_wndPEditor.SetTool(0);
}

void CPtnEd::OnPtneditPen() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	SetToolButton(ID_PTNEDIT_PEN);
	m_wndPEditor.SetTool(1);
}

void CPtnEd::OnPtneditLine() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	SetToolButton(ID_PTNEDIT_LINE);
	m_wndPEditor.SetTool(2);
}

void CPtnEd::OnPtneditCircle() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	SetToolButton(ID_PTNEDIT_CIRCLE);
	m_wndPEditor.SetTool(3);
}


void CPtnEd::OnInitMenu(CMenu* pMenu) 
{
	CDialog::OnInitMenu(pMenu);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	UINT nEnable1;	//p^[݂Enable
	UINT nEnable2;  //ꎞp^[ Enable
	UINT nEnable3;	//Nbv{[hɗLȃf[^ Enable
	UINT nEnable4;	//Undo\ȂEnable;
	
	nEnable1=nEnable2=nEnable3=nEnable4=MF_GRAYED;
	int nTool=m_wndPEditor.GetTool();

	if(m_wndPEditor.GetPtnPtr()!=NULL){
		nEnable1=MF_ENABLED;
		if(::IsClipboardFormatAvailable(CF_BITMAP)) nEnable3=MF_ENABLED;
	}
	if(m_wndPEditor.CanCopy()!=FALSE && nTool==0)  nEnable2=MF_ENABLED;
	if(m_wndPEditor.CanUndo()!=FALSE)  nEnable4=MF_ENABLED;

	pMenu->EnableMenuItem(ID_ZOOMIN,			nEnable1);
	pMenu->EnableMenuItem(ID_ZOOMOUT,			nEnable1);
	pMenu->EnableMenuItem(ID_EDITPTN_RENAME,	nEnable1);
	pMenu->EnableMenuItem(ID_EDITPTN_ATTRIBUTE,	nEnable1);
	pMenu->EnableMenuItem(ID_EDITPTN_DEL,		nEnable1);

	pMenu->EnableMenuItem(ID_EDIT_CUT,		nEnable2);
	pMenu->EnableMenuItem(ID_EDIT_COPY,		nEnable2);
	pMenu->EnableMenuItem(ID_EDIT_CLEAR,	nEnable2);

	pMenu->EnableMenuItem(ID_EDIT_PASTE,	nEnable3);

	pMenu->EnableMenuItem(ID_EDIT_UNDO,		nEnable4);
}


void CPtnEd::OnEditCopy() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_wndPEditor.CanCopy()==FALSE)return;
	m_wndPEditor.Copy();
}

void CPtnEd::OnEditPaste() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_wndPEditor.Paste();
	
}

void CPtnEd::OnEditClear() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_wndPEditor.CanCopy()==FALSE)return;
	m_wndPEditor.Clear();
}

void CPtnEd::OnEditCut() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_wndPEditor.CanCopy()==FALSE)return;
	m_wndPEditor.Copy();
	m_wndPEditor.Clear();
}



void CPtnEd::OnEditptnRename() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_wndPEditor.FixTemp();
	m_wndPEditor.Invalidate();

	CRnPtn dlg;

	CComboBox* pCombo=(CComboBox*)GetDlgItem(IDC_COMBO_PTN);
	int nIndex=pCombo->GetCurSel();
	CLCoPtn* pPtn=(CLCoPtn*)pCombo->GetItemDataPtr(nIndex);
	dlg.m_strName=pPtn->m_strName;
	if(IDOK==dlg.DoModal()){
		pPtn->m_strName=dlg.m_strName;
		//CfbNX̕폜
		pCombo->DeleteString(nIndex);
		//VOœo^
		char sz[64];
		wsprintf(sz,"%dx%d  %s",pPtn->m_size.cx/10,pPtn->m_size.cy/10,pPtn->m_strName);
		nIndex=pCombo->AddString(sz);
		//CfbNX̃f[^ēo^
		pCombo->SetItemDataPtr(nIndex,pPtn);
		//I
		pCombo->SetCurSel(nIndex);
		m_bChange|=TRUE;
	}
}

#define NEWPTN_X 21
#define NEWPTN_Y 21
#define NEWPTN_BUFFSIZE (((NEWPTN_X+15)/16)*2*NEWPTN_Y)


void CPtnEd::OnEditptnNew() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_wndPEditor.FixTemp();
	m_wndPEditor.Invalidate();

	CRnPtn dlg;
	dlg.m_strCaption.LoadString(IDS_NEWPTN_CAPTION);
	if(IDOK==dlg.DoModal()){
		CLCoPtn* pPtn=new CLCoPtn;
		pPtn->m_size=CSize(NEWPTN_X,NEWPTN_Y);
		pPtn->m_pBuff=new BYTE[NEWPTN_BUFFSIZE];
		int n;
		for(n=0;n<NEWPTN_BUFFSIZE;n++)pPtn->m_pBuff[n]=0;

		pPtn->m_strName=dlg.m_strName;

		//p^[̃Xgւ̒ǉ
		m_pListPtn->AddTail(pPtn);
		

		//R{{bNXւ̓o^
		CComboBox* pCombo=(CComboBox*)GetDlgItem(IDC_COMBO_PTN);
		char sz[64];
		wsprintf(sz,"%dx%d  %s",pPtn->m_size.cx/10,pPtn->m_size.cy/10,pPtn->m_strName);
		int nIndex=pCombo->AddString(sz);
		//CfbNX̃f[^o^
		pCombo->SetItemDataPtr(nIndex,pPtn);
		//I
		pCombo->SetCurSel(nIndex);

		m_wndPEditor.SetPtnPtr(pPtn);

		m_bChange|=TRUE;
	}
}

void CPtnEd::OnEditptnAttribute() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_wndPEditor.FixTemp();
	m_wndPEditor.Invalidate();

	CPtnSize dlg;

	CComboBox* pCombo=(CComboBox*)GetDlgItem(IDC_COMBO_PTN);
	int nIndex=pCombo->GetCurSel();
	CLCoPtn* pPtn=(CLCoPtn*)pCombo->GetItemDataPtr(nIndex);
	dlg.m_nX=pPtn->m_size.cx;
	dlg.m_nY=pPtn->m_size.cy;
	if(IDOK==dlg.DoModal()){
		if(   dlg.m_nX==pPtn->m_size.cx
		   && dlg.m_nY==pPtn->m_size.cy )return;
		//Vp^[̃obt@mۂĂƂ̃p^[畡
		int nTferXByte,nTferY;
		int nSXbyte,nDXbyte;
		BYTE *pSXtop,*pDXtop,*pS,*pD;
		int nNewBuffSize;
		int n,m,x,y;
		BYTE bRmask;

		nSXbyte=((pPtn->m_size.cx+15)/16)*2;
		nDXbyte=((dlg.m_nX+15)/16)*2;
		nNewBuffSize=nDXbyte*dlg.m_nY;
		
		BYTE* pNewBuff=new BYTE[nNewBuffSize];
		for(n=0;n<nNewBuffSize;n++) pNewBuff[n]=0;
		pSXtop=pPtn->m_pBuff;
		pDXtop=pNewBuff;

		n=(pPtn->m_size.cx+7)/8;	//]̃p^[ƂėLXoCg
		x=(dlg.m_nX+7)/8;			//]̃p^[ƂėLXoCg
		if(n<x){
			nTferXByte=n;
			m=pPtn->m_size.cx;
		}else{
			nTferXByte=x;
			m=dlg.m_nX;
		}
		m=m%8;
		if(!m)	bRmask=0xFF;
		else	bRmask=0xFF & (0xFF00>>m);
		
		if(pPtn->m_size.cy<dlg.m_nY)nTferY=pPtn->m_size.cy;
		else nTferY=dlg.m_nY;
		for(y=0;y<nTferY;y++){
			pS=pSXtop; pSXtop+=nSXbyte;
			pD=pDXtop; pDXtop+=nDXbyte;
			x=0;
			for(;;){
				*pD=*pS++;
				x++;
				if(x==nTferXByte){
					*pD &=bRmask;
					break;
				}
				pD++;
			}
		}
		//Âp^[̍폜
		delete[]pPtn->m_pBuff;
		//Vp^[蓖Ă
		pPtn->m_pBuff=pNewBuff;

		//Vp^[TCY̐ݒ
		pPtn->m_size.cx=dlg.m_nX;
		pPtn->m_size.cy=dlg.m_nY;

		//R{{bNXւ̓o^Ȃ
		//CfbNX̕폜
		pCombo->DeleteString(nIndex);
		//VTCYœo^
		char sz[64];
		wsprintf(sz,"%dx%d  %s",pPtn->m_size.cx/10,pPtn->m_size.cy/10,pPtn->m_strName);
		nIndex=pCombo->AddString(sz);
		//CfbNX̃f[^ēo^
		pCombo->SetItemDataPtr(nIndex,pPtn);
		//I
		pCombo->SetCurSel(nIndex);

		m_wndPEditor.SetPtnPtr(pPtn);

		m_bChange|=TRUE;
	}
}


//p^[̍폜
void CPtnEd::OnEditptnDel() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CComboBox* pCombo=(CComboBox*)GetDlgItem(IDC_COMBO_PTN);
	if(pCombo->GetCount()==0) return;
	int nIndex=pCombo->GetCurSel();
	CLCoPtn* pPtn=(CLCoPtn*)pCombo->GetItemDataPtr(nIndex);

	CStringList strlist;
	CTypedPtrList<CPtrList, CColListData*>* pColListData;

	CLCoDlg* pMainWnd=(CLCoDlg*)AfxGetMainWnd();
	pColListData=&(pMainWnd->m_wndColList.m_listData);

	POSITION pos=pColListData->GetHeadPosition();
	while(pos){
		CColListData* pData=pColListData->GetNext(pos);
		CLCoPartInfo* pPartInfo=(CLCoPartInfo*)(pData->m_dwData);
		if(pPartInfo->m_pPtn ==pPtn) strlist.AddTail(pData->m_str);
	}
	if(strlist.IsEmpty()){
		if(AfxMessageBox(IDS_PTN_DELETE,MB_YESNO)==IDYES){
			pos=m_pListPtn->Find(pPtn);
			if(pos)	m_pListPtn->RemoveAt(pos);
			delete pPtn;
			//R{{bNX̕폜
			pCombo->DeleteString(nIndex);
			int nCount=pCombo->GetCount();
			//VڂI
			if(nCount<=nIndex) nIndex=nCount-1;
			pCombo->SetCurSel(nIndex);
			if(nCount==0) m_wndPEditor.SetPtnPtr(NULL);
			else{
				pPtn=(CLCoPtn*)pCombo->GetItemDataPtr(nIndex);
				m_wndPEditor.SetPtnPtr(pPtn);
			}
			m_bChange|=TRUE;
		}
	}else{
		CUsePtn dlg;
		dlg.m_pStrList=&strlist;
		dlg.DoModal();
	}
}

void CPtnEd::OnEditUndo() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	m_wndPEditor.Undo();
}
